//*****************************************************************************
// File Name            : hello_world_small.c
//-----------------------------------------------------------------------------
// Function             : camera set up
//
//-----------------------------------------------------------------------------
// Designer             : yokomizo@himwari_co
//-----------------------------------------------------------------------------
// History
// -.-- 2017/7/25
//*****************************************************************************
#include "system.h"
#include "altera_avalon_i2c_regs.h"
void w_ov9650(alt_u8 addr,alt_u8 wdata);
alt_u8 r_ov9650(alt_u8 addr);

int main()
{ int i=0;
  volatile int dly;
  //int reg_data;
  alt_u8 reg_init_data[][2]=
  {{0x12,0x80},
   {0x12,0x63},
   {0x40,0xd0},
   {0x00,0x00},
   {0x01,0x80},
   {0x02,0x80},
   {0xb5,0x00},
   {0x35,0x80},
   {0xa8,0xc1},
   {0x3a,0xcc},
   {0x3d,0x99},
   {0x77,0x02},
   {0x13,0xe7},
   {0x26,0x72},
   {0x27,0x08},
   {0x28,0x08},
   {0x2c,0x08},
   {0xab,0x04},
   {0x6e,0x00},
   {0x6d,0x55},
   {0x00,0x11},
   {0x10,0x7b},
   {0xbb,0xae},
   {0x11,0x03},
   {0x72,0x00},
   {0x3e,0x0c},
   {0x74,0x3a},
   {0x76,0x01},
   {0x75,0x35},
   {0x73,0x00},
   {0xc7,0x80},
   {0x62,0x00},
   {0x63,0x00},
   {0x64,0x02},
   {0x65,0x20},
   {0x66,0x01},
   {0xc3,0x4e},
   {0x33,0x00},
   {0xa4,0x50},
   {0xaa,0x92},
   {0xc2,0x01},
   {0xc1,0xc8},
   {0x1e,0x34},
   {0xa9,0xef},
   {0x0e,0x61},
   {0x39,0x57},
   {0x0f,0x48},
   {0x24,0x3c},
   {0x25,0x36},
   {0x12,0x63},
   {0x03,0x12},
   {0x32,0xff},
   {0x17,0x16},
   {0x18,0x02},
   {0x19,0x01},
   {0x1a,0x3d},
   {0x36,0xfa},
   {0x69,0x0a},
   {0x8c,0x8d},
   {0xc0,0xaa},
   {0x40,0xd0},
   {0x43,0x14},
   {0x44,0xf0},
   {0x45,0x46},
   {0x46,0x62},
   {0x47,0x2a},
   {0x48,0x3c},
   {0x59,0x85},
   {0x5a,0xa9},
   {0x5b,0x64},
   {0x5c,0x84},
   {0x5d,0x53},
   {0x5e,0x0e},
   {0x6c,0x0c},
   {0xc6,0x85},
   {0xcb,0xf0},
   {0xcc,0xd8},
   {0x71,0x78},
   {0xa5,0x68},
   {0x6f,0x9e},
   {0x42,0xc0},
   {0x3f,0x82},
   {0x8a,0x23},
   {0x14,0x3a},
   {0x3b,0xcc},
   {0x34,0x3d},
   {0x41,0x40},
   {0xc9,0xe0},
   {0xca,0xe8},
   {0xcd,0x93},
   {0x7a,0x20},
   {0x7b,0x1c},
   {0x7c,0x28},
   {0x7d,0x3c},
   {0x7e,0x5a},
   {0x7f,0x68},
   {0x80,0x76},
   {0x81,0x80},
   {0x82,0x88},
   {0x83,0x8f},
   {0x84,0x96},
   {0x85,0xa3},
   {0x86,0xaf},
   {0x87,0xc4},
   {0x88,0xd7},
   {0x89,0xe8},
   {0x4f,0x98},
   {0x50,0x98},
   {0x51,0x00},
   {0x52,0x28},
   {0x53,0x70},
   {0x54,0x98},
   {0x58,0x1a},
   {0x6b,0x5a},
   {0x90,0x92},
   {0x91,0x92},
   {0x9f,0x90},
   {0xa0,0x90},
   {0x16,0x24},
   {0x2a,0x00},
   {0x2b,0x00},
   {0xac,0x80},
   {0xad,0x80},
   {0xae,0x80},
   {0xaf,0x80},
   {0xb2,0xf2},
   {0xb3,0x20},
   {0xb4,0x20},
   {0xb6,0xaf},
   {0x29,0x15},
   {0x9d,0x02},
   {0x9e,0x02},
   {0x9e,0x02},
   {0x04,0x03},
   {0x05,0x2e},
   {0x06,0x2e},
   {0x07,0x2e},
   {0x08,0x2e},
   {0x2f,0x2e},
   {0x4a,0xe9},
   {0x4b,0xdd},
   {0x4c,0xdd},
   {0x4d,0xdd},
   {0x4e,0xdd},
   {0x70,0x06},
   {0xa6,0x40},
   {0xbc,0x02},
   {0xbd,0x01},
   {0xbe,0x02},
   {0xbf,0x01},
   {0x56,0x30},
   {0x55,0x04},
   {0xff,0xff}
  };
  //alt_putstr("Hello from Nios II!\n");

  IOWR(I2C_0_BASE,2,0x3);   //i2c enable
  //OV9650 SCCB
  while(1){
  if(reg_init_data[i][0]==0xff)
	  break;
  w_ov9650(reg_init_data[i][0],reg_init_data[i][1]);
  //alt_printf("OV9650 adr=%x wdata=%x\n",reg_init_data[i][0],reg_init_data[i][1]);
  i++;
  for(dly=0;dly<500;dly++);
  }
  alt_putstr("!\n");
  /* Event loop never exits. */
  while (1);

  return 0;
}

void w_ov9650(alt_u8 addr,alt_u8 wdata){
	  IOWR(I2C_0_BASE,0,0x60);  //slv adr(0x30) w
	  IOWR(I2C_0_BASE,0,addr);  //adr 0x80
	  IOWR(I2C_0_BASE,0,(0x100 + wdata)); //wdata 0x84 ,stop
	  while(IORD(I2C_0_BASE,5)!=0);
};

alt_u8 r_ov9650(alt_u8 addr){
	  IOWR(I2C_0_BASE,0,0x60);  //slv adr(0x30) w
	  IOWR(I2C_0_BASE,0,(0x100 + addr)); //adr ,stop
	  while(IORD(I2C_0_BASE,5)!=0);
	  IOWR(I2C_0_BASE,0,0x61);  //slv adr(0x30) r
	  IOWR(I2C_0_BASE,0,0x100); //read data ,stop
	  while(IORD(I2C_0_BASE,5)!=0);
	  return IORD(I2C_0_BASE,1);
};
